#   xmclock - A Different Way to Pass the Time 
#   version 1.2
#
#   From collapsar.org
#   Copyright 1998
#
#   xmclock is distributed under the GNU General Public Licence.
#   xmclock comes with ABSOLUTELY NO WARRANTY or GUARANTEE OF FITNESS
#   FOR A PARTICULAR PURPOSE.  See the file COPYING or the ABOUT window
#   for complete information.
#
puts ""
puts "xmclock is distributed under the GNU General Public Licence."
puts "xmclock comes with ABSOLUTELY NO WARRANTY or GUARANTEE OF FITNESS"
puts "FOR A PARTICULAR PURPOSE.  See the file COPYING or the ABOUT window"
puts "for complete information."

# initialize variables...
set xmcdir      /usr/local/bin
set xmclib      /usr/local/share/xmclock
set k           50
set precision   3
set fontsize    250
set oldfntsz    250
set showdate    0
set oldshowdate 0
set chrono      0
set oldchrono   0
set alarm       0
set oldalarm    0
set standard    0
set oldstandard 0
set etime       0
set stime       0
set menuon      0
set alarm_time  0
set quitflag    0
set tminus      0

# read ~/.xmclockrc if it exists
set data ""
set filename "~/.xmclockrc"
if { [file readable $filename] } {
    set fileid [open $filename "r"]
    set data [read $fileid]
    close $fileid
    scan "$data" "%s %s %s %s %s %s %s" precision fontsize oldfntsiz \
	showdate standard menuon chrono
   }

# global packs and binds
frame .main
frame .main.time
label .main.time.mtime -textvariable mtime \
	-font "-bitstream-courier-medium-r-normal-*-*-$fontsize-*-*-*-*-*-*"
wm title . "xmclock 1.2"
pack .main.time.mtime
pack .main.time
pack .main

bind all <Alt-q> { set quitflag 666 }
bind all <Alt-m> { if {$menuon == 0} then {build_menu} \
			   else {set menuon [kill_menu]}}
bind all <2> {if {$menuon == 0} then {build_menu} \
		  else {set menuon [kill_menu]}}
bind all <3> {if {$fontsize == 400} then {set fontsize 100} \
		  else {set fontsize [expr $fontsize + 75]}}
bind all <Control-Alt-1> \
	{ tk_dialog .truth "My Humble Opinion" "Microsoft sucks!" \
	    info 0 Right_On! }

##########################################################################
# build_menu {}
#
# parameters: none
#
# function: assembles/binds/displays Menubar at top of window
##########################################################################
proc build_menu {} {
    global menuon
    global xmcdir
if {$menuon != 2} {
    frame .menubar -relief ridge -borderwidth 3
    menubutton .menubar.ctrl -text "Control" -menu .menubar.ctrl.menu \
	-relief groove -borderwidth 3 -underline 0
    pack .menubar.ctrl -side left
    menu .menubar.ctrl.menu
	.menubar.ctrl.menu add cascade -label "Precision" -menu \
	    .menubar.ctrl.menu.precision
	.menubar.ctrl.menu add cascade -label "Font" -menu \
	    .menubar.ctrl.menu.font
	.menubar.ctrl.menu add cascade -label "Subdisplays" -menu \
	    .menubar.ctrl.menu.sub
	.menubar.ctrl.menu add separator
	.menubar.ctrl.menu add command -label "Time Converter" \
	    -command { exec wish -f "$xmclib/xmconvert.tcl" } 
	.menubar.ctrl.menu add separator
	.menubar.ctrl.menu add command -label "Toggle Menu" \
	    -accelerator "Alt-M" -command {kill_menu}
	.menubar.ctrl.menu add command -label "Exit" \
	    -accelerator "Alt-Q" -command {set quitflag 666}
	    menu .menubar.ctrl.menu.precision
		.menubar.ctrl.menu.precision add radiobutton \
		-label "0 Places (millidays)" -variable precision -value 0 
		.menubar.ctrl.menu.precision add radiobutton \
		-label "1 Places (Day/10000)" -variable precision -value 1 
		.menubar.ctrl.menu.precision add radiobutton \
		-label "2 Places (Day/100000)" -variable precision -value 2
		.menubar.ctrl.menu.precision add radiobutton \
		-label "3 Places (microdays)" -variable precision -value 3 
	    menu .menubar.ctrl.menu.font
		.menubar.ctrl.menu.font add radiobutton -label "400 Point" \
		    -variable fontsize -value 400 
		.menubar.ctrl.menu.font add radiobutton -label "325 Point" \
		    -variable fontsize -value 325 
		.menubar.ctrl.menu.font add radiobutton -label "250 Point" \
		    -variable fontsize -value 250 
		.menubar.ctrl.menu.font add radiobutton -label "175 Point" \
		    -variable fontsize -value 175 
		.menubar.ctrl.menu.font add radiobutton -label "100 Point" \
		    -variable fontsize -value 100
	    menu .menubar.ctrl.menu.sub
		.menubar.ctrl.menu.sub add checkbutton -label "Standard Time" \
		    -variable standard -onvalue 1 -offvalue 0
		.menubar.ctrl.menu.sub add checkbutton -label "Chronograph" \
		    -variable chrono -onvalue 1 -offvalue 0
		.menubar.ctrl.menu.sub add checkbutton -label "Date" \
		    -variable showdate -onvalue 1 -offvalue 0
		.menubar.ctrl.menu.sub add checkbutton -label "Alarm" \
		    -variable alarm -onvalue 1 -offvalue 0
    menubutton .menubar.help -text "Help" -menu .menubar.help.menu \
	-relief groove -borderwidth 3 -underline 0
    pack .menubar.help -side right
    menu .menubar.help.menu
    .menubar.help.menu add command -label "Help on xmclock" \
	    -command { exec xb "$xmclib/Help_on_xmclock" }
    .menubar.help.menu add command -label "Help on Time Converter" \
	    -command { exec xb "$xmclib/Help_on_xmconv" }
    .menubar.help.menu add command -label "Help on Time" \
	    -command { exec xb "$xmclib/Help_on_Time" }
    .menubar.help.menu add separator
    .menubar.help.menu add command -label "ASCII Chart" \
	    -command { exec xb "$xmclib/ASCII_Chart"}
    .menubar.help.menu add separator
    .menubar.help.menu add command -label "About xmclock" \
	    -command {about_window}
    pack .menubar -side top -before .main -fill x -expand true
    set menuon 1
    } else { set menuon 0 }
}

##########################################################################
# kill_menu {}
#
# parameters: none
#
# function: destroys menubar - return 0 into variable menuon
##########################################################################
proc kill_menu {} {
    destroy .menubar
    return 0
}

##########################################################################
# about_window {}
#
# parameters: none
#
# function: displays the 'about' window (suprise, suprise!)
##########################################################################
proc about_window {} {
    global xmcdir
    global xmclib
    image create photo logo -file $xmclib/xmcdlogo.gif
    toplevel .about -class Dialog
    frame .about.picholder -relief ridge -borderwidth 3
    label .about.title -text "Version 1.2, 06 December 1998"
    label .about.authr -text "From collapsar.org"
    label .about.picholder.pic   -image logo
    button .about.quit -text "I Can Dig It!" -command { destroy .about } \
	    -activebackground yellow -relief groove
    button .about.info -text "xmclock has ABSOLUTELY NO WARRANTY!" \
	    -command {exec xb $xmclib/COPYING} \
	    -activebackground orange -relief groove
    set width [winfo screenwidth  .]
    set height [winfo screenwidth .]
    set x [expr ($width/2) - 250]
    set y [expr ($height/2) - 250]
    wm transient .about .
    wm geometry .about +$x+$y
    pack .about.title
    pack .about.picholder -padx 10 -pady 2
    pack .about.picholder.pic
    pack .about.authr
    pack .about.quit -side left -padx 1 -pady 5
    pack .about.info -side right -padx 1 -pady 5
}

##########################################################################
# change_font {}
#
# parameters: none
#
# function: switches display font size
##########################################################################
proc change_font {} {
    global fontsize
    global oldfntsz
    global standard
    set oldfntsz $fontsize
    destroy .main.time.mtime
    label .main.time.mtime -textvariable mtime \
	-font "-bitstream-courier-medium-r-normal-*-*-$fontsize-*-*-*-*-*-*"
    pack .main.time.mtime
    if {$standard == 1} then {
	destroy .main.time.stime
	label .main.time.stime -textvariable stime \
		-font "-bitstream-courier-medium-r-normal-*-*-$fontsize-*-*-*-*-*-*"
	pack .main.time.stime
    }
}

##########################################################################
# set_stime {}
#
# parameters: none
#
# function: creates/destroys standard time display
##########################################################################
proc set_stime {} {
    global standard
    global oldstandard
    global fontsize
    set oldstandard $standard
    if {$standard == 0} then {destroy .main.time.stime}
    if {$standard == 1} then {
	label .main.time.stime -textvariable stime \
		-font "-bitstream-courier-medium-r-normal-*-*-$fontsize-*-*-*-*-*-*"
	pack .main.time.stime
    }
}

##########################################################################
# set_chrono {}
#
# parameters: none
#
# function: creates/destroys chronograph (elapsed time) display
##########################################################################
proc set_chrono {} {
    global oldtime
    global oldchrono
    global chrono
    global chron_mtime
    global etime
    global showdate
    set oldchrono $chrono
    if {$chrono == 0} then {
	set etime 0
	destroy .main.chrono
    }
    if {$chrono == 1} then {
	set oldtime $chron_mtime
	label .main.chrono -textvariable etime -relief ridge -bg orange
	if {$showdate == 0} then {
	    pack .main.chrono -side left
	}
	if {$showdate == 1} then {
	    pack configure .main.chrono -before .main.date -side left
	} 
    }
}

##########################################################################
# set_date {}
#
# parameters: none
#
# function: creates/destroys date subdisplay
##########################################################################
proc set_date {} {
    global showdate
    global oldshowdate
    global date
    global chrono
    set oldshowdate $showdate
    if {$showdate == 0} then {
	destroy .main.date
    }
    if {$showdate == 1} then {
	set date [exec date]
	scan "$date" "%s %s %s %s %s %s" day month day_num wholetime tz year
	set date "$day $month $day_num , $year"
	label .main.date -textvariable date -bg green -relief ridge
	if {$chrono == 0} then {pack .main.date -side left}
	if {$chrono == 1} then {
	    pack configure .main.date -side left
	}
    }
}

##########################################################################
# set_alarm {}
#
# parameters: none
#
# function: creates/destroys alarm display. handles alarm.
##########################################################################
proc set_alarm {} {
    global alarm
    global alarm_time
    global oldalarm
    global showdate
    global tminus
    if {$alarm == 2} {
	destroy .main.alarm
	set alarm_time 0
	frame  .main.alarm -relief ridge -borderwidth 3 -bg red
	button .main.alarm.quitit -text "ALARM" \
		-command {destroy .main.alarm} -bg red -activebackground red
	pack .main.alarm.quitit
	if {$showdate == 0} then {
	    pack .main.alarm -side right
	}
	if {$showdate == 1} then {
	    pack configure .main.alarm -after .main.date -side right
	}
	for {set j 0} {$j < 15} {incr j} {
	    bell
	    after 130
	}
    }
    set oldalarm $alarm
    if {$alarm == 1} {
	label .main.alarm -textvariable tminus -relief ridge -bg red
	if {$showdate == 0} then {
	    pack .main.alarm -side right
	}
	if {$showdate == 1} then {
	    pack configure .main.alarm -after .main.date -side right
	}
	set alarm_time x
	toplevel .getalarm
	label .getalarm.title -text "What time to set for?"
	entry .getalarm.enter -width 8
	set width [winfo screenwidth  .]
	set height [winfo screenwidth .]
	set x [expr ($width/2) - 150]
	set y [expr ($height/2) - 150]
	wm transient .getalarm .
	wm geometry .getalarm +$x+$y
	pack .getalarm.title .getalarm.enter -side left
	bind .getalarm.enter <Key-Return> {
	    set alarm_time [.getalarm.enter get]
	    destroy .getalarm
	}
    }
    if {$alarm == 0} then {
	if {$alarm_time == "x"} then {destroy .getalarm}
	destroy .main.alarm
    }
}

##########################################################################
# calc_mtime {}
#
# parameters: standard
#
# function: sets all current times for display
##########################################################################
proc calc_mtime {standard} {
    global k
    global total_secs
    global stime
    if {$k < 50} then {
	after 86
	set total_secs [expr $total_secs + 0.1]
	incr k
    }
    if {$k == 50} then {
	set k 1
	#get time from system
	set std_time [clock format [clock seconds] -format "%H %M %S"]
	scan "$std_time" "%d %d %d" std_hrs std_min std_sec
	#calculate total elapsed seconds
	set total_secs [expr ($std_hrs * 60 * 60) + ($std_min * 60) + $std_sec]
	#set standard time (if needed)
	if {$standard == 1} then {
	    if {$std_hrs < 10} then {set std_hrs [format "0%s" $std_hrs]}
	    if {$std_min < 10} then {set std_min [format "0%s" $std_min]}
	    if {$std_sec < 10} then {set std_sec [format "0%s" $std_sec]}
	    set stime [format "%s:%s:%s" $std_hrs $std_min $std_sec]
	}
    }
    #calculate metric time
    return [expr $total_secs / 86.4]

}

##########################################################################
# kill_program {}
#
# parameters: none
#
# function: saves current settings as ~/.xmclockrc
##########################################################################
proc kill_program {} {
    global filename
    global precision
    global fontsize
    global oldfntsz
    global showdate
    global standard
    global menuon
    global chrono
    if {$menuon == 0} {set menuon 2}
    set fileid [open $filename "w"]
    puts $fileid $precision
    puts $fileid $fontsize
    puts $fileid $oldfntsz
    puts $fileid $showdate
    puts $fileid $standard
    puts $fileid $menuon
    puts $fileid $chrono
    close $fileid
    exit
}

build_menu

while { 1 } {
    if { $quitflag == 666 } then { kill_program }
    if { $standard != $oldstandard } then {set_stime}
    if { $fontsize != $oldfntsz } then { change_font }
    if { $alarm != $oldalarm } then {set_alarm}
    if { $showdate != $oldshowdate } then {set_date}
    set chron_mtime [calc_mtime $standard]
    if { $chrono != $oldchrono } then {set_chrono}
    if {$chron_mtime > 999.997} then {
	set k 50
	set chron_mtime [calc_mtime $standard]
	if {$showdate == 1} then {
	    destroy .main.date
	    set_date
	}
    }
    if {$chron_mtime < 10} then {
	if {$precision == 0} then {set mtime [format "00%.0f" $chron_mtime ]}
	if {$precision == 1} then {set mtime [format "00%.1f" $chron_mtime ]}
	if {$precision == 2} then {set mtime [format "00%.2f" $chron_mtime ]}
	if {$precision == 3} then {set mtime [format "00%.3f" $chron_mtime ]}
    }
    if {$chron_mtime >= 10 && $chron_mtime < 100} then {
	if {$precision == 0} then {set mtime [format "0%.0f" $chron_mtime ]}
	if {$precision == 1} then {set mtime [format "0%.1f" $chron_mtime ]}
	if {$precision == 2} then {set mtime [format "0%.2f" $chron_mtime ]}
	if {$precision == 3} then {set mtime [format "0%.3f" $chron_mtime ]}
    }
    if {$chron_mtime >= 100} then {
	if {$precision == 0} then {set mtime [format "%.0f" $chron_mtime ]}
	if {$precision == 1} then {set mtime [format "%.1f" $chron_mtime ]}
	if {$precision == 2} then {set mtime [format "%.2f" $chron_mtime ]}
	if {$precision == 3} then {set mtime [format "%.3f" $chron_mtime ]}
    }

    if { $chrono == 1 } then {
	set diff [expr $chron_mtime - $oldtime]
	set etime [expr $etime + $diff]
        if {$etime >= 100} then {set etime [format "%.3f" $etime]}
        if {$etime >= 10 } then {set etime [format "0%.3f" $etime]}
        if {$etime <  10 } then {set etime [format "00%.3f" $etime]}
	set oldtime $chron_mtime
    }
    if { $alarm == 1 } then {
	if {$alarm_time != "x"} then {
	    set tminus [expr $alarm_time - $chron_mtime]
	    if {$tminus >= 100} then {set tminus [format "%.3f" $tminus]}
	    if {$tminus >= 10 } then {set tminus [format "0%.3f" $tminus]}
	    if {$tminus <  10 } then {set tminus [format "00%.3f" $tminus]}
	    if {$tminus < 0.02 && $tminus > -0.02} then {
		set alarm 2
		set_alarm
		set alarm 0
		set oldalarm 0
	    }
	}
    }
    update
}
